找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1252|回复: 17

[每日一码] 如何把UCS对齐于弧或圆

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2016-8-1 18:24:57 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
本帖最后由 newer 于 2016-8-1 18:27 编辑

问题:
我需要把UCS对齐于弧线实体,我试了用UCS命令跟着E选项,但是我不能控制X、Y的旋转角,我要如何做才能把UCS对齐于弧线呢?
I need to align the UCS with an arc entity in my drawing. I tried using UCS
command with the Entity (E)option, but I have no control over the rotation of
the X and Y axes. How can I set my UCS to correspond with the geometry of my
arc?

回答:
You can use ActiveX from within AutoLISP to create your own UCS based upon the
geometry of your arc entity.  Using ActiveX, you can obtain the arc's normal and
create a vector between the center and the startpoint, then calculate the third
axis from the cross product of the two. Use the Add method of the AcadUCSs
object to create a custom UCS based on the origin of the arc and points along
the X and Y axes, then make the new custom UCS current. The result will change
the UCS to make the origin correspond with the Arc's center, the Y axis will
point to the Startpoint ,the Z Axis will correspond with the arc's normal and
the X Axis will be calculated to be orthogonal to both according to the
right-hand rule. The same solution can be used with circle entities as well with
only slight modifications.

The following example is written n in Visual LISP that performs the operation:
QQ截图20160801182059.png

  1. (defun C:UcsArc ()
  2. (vl-load-com)
  3. (setq acadObject (vlax-get-acad-object))
  4. (setq acadDoc (vla-Get-ActiveDocument acadObject))
  5. (setq anEnt (entsel "Select an Arc: "))
  6. (if anEnt
  7.    (progn
  8.      (setq entLst (entget (car anEnt) '("*")))
  9.      (if (equal (cdr (assoc '0 entLst)) "ARC")
  10.             (progn
  11.               (setq arcObj (vlax-ename->vla-object (car anEnt)))
  12.               (setq strtPt (vla-Get-StartPoint arcObj))
  13.               (setq strtPtLst (vlax-safearray->list (vlax-variant-value strtPt)))
  14.               (setq ctrPt (vla-Get-Center arcObj))
  15.               (setq ctrPtLst (vlax-safearray->list (vlax-variant-value ctrPt)))
  16.               (setq Norm (vla-Get-Normal arcObj))
  17.               (setq NormLst (vlax-safearray->list (vlax-variant-value Norm)))
  18.               (setq startVector (doListMinus strtPtLst ctrPtLst))
  19.               (setq r1Vector (doCrossProduct NormLst startVector))
  20.               (setq XAxis (doListMinus ctrPtLst r1Vector))
  21.               (setq UCScollection (vla-Get-UserCoordinateSystems acadDoc))
  22.               (setq ucsOrigin (vlax-3d-Point ctrPtLst) XAxisPoint (vlax-3d-Point
  23. XAxis) YAxisPoint (vlax-3d-Point strtPtLst))
  24.               (if (setq newUCS (vla-Add UCScollection ucsOrigin XAxisPoint
  25. YAxisPoint "ArcUcs"))
  26.                 (princ "Created UCS Definition: ArcUcs"))
  27.               (vla-put-ActiveUCS acadDoc newUCS)
  28.               (if(not(vlax-object-released-p arcObj))
  29.                 (vlax-release-object arcObj))
  30.               (if(not(vlax-object-released-p UCScollection))
  31.                 (vlax-release-object UCScollection))
  32.               )
  33.             )
  34.      )
  35.    )
  36. (if(not(vlax-object-released-p acadObject))
  37.   (vlax-release-object acadObject))
  38. (if(not(vlax-object-released-p acadDoc))
  39.   (vlax-release-object acadDoc))
  40. (princ)
  41. )

  42. ; (setq FstLst strtPtLst S**Lst ctr)
  43. (defun doListMinus (FstLst S**Lst)
  44. (setq X (- (car FstLst) (car S**Lst)))
  45. (setq Y (- (cadr FstLst) (cadr S**Lst)))
  46. (setq Z (- (caddr FstLst) (caddr S**Lst)))
  47. (list X Y Z)
  48. )



求叉积的函数:

游客,如果您要查看本帖隐藏内容请回复




论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 5570个

财富等级: 富甲天下

发表于 2016-8-2 07:42:55 | 显示全部楼层
谢谢版主的源码,回复,向版主学习
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 5570个

财富等级: 富甲天下

发表于 2016-8-2 07:46:06 | 显示全部楼层
谢谢版主的源码,回复,向版主学习
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 859个

财富等级: 财运亨通

发表于 2016-8-2 10:16:23 | 显示全部楼层
有点 和 firstderiv  就有了 原点、X 轴 和 xy 平面上点,使用 UCS 命令 也可以
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2963个

财富等级: 家财万贯

发表于 2016-8-2 12:20:24 | 显示全部楼层
good good.
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 126个

财富等级: 日进斗金

发表于 2016-8-2 12:52:59 | 显示全部楼层
向版主学习
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2476个

财富等级: 金玉满堂

发表于 2016-8-2 17:34:47 | 显示全部楼层
对齐于圆弧怎么讲...
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 568个

财富等级: 财运亨通

发表于 2016-9-4 20:49:36 | 显示全部楼层
我也正在学习ucs命令
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 6056个

财富等级: 富甲天下

发表于 2016-11-20 19:13:22 | 显示全部楼层
 精彩好文。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1336个

财富等级: 财源广进

发表于 2017-7-21 13:01:07 | 显示全部楼层
回复学习下!多谢分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 215个

财富等级: 日进斗金

发表于 2020-1-17 14:05:12 | 显示全部楼层
顶一顶顶一顶
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2020-2-3 00:18:21 | 显示全部楼层

回复学习下!多谢分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 8684个

财富等级: 富甲天下

发表于 2020-2-3 18:14:51 | 显示全部楼层
回复学习!谢谢分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 4803个

财富等级: 富可敌国

发表于 2020-2-5 15:15:47 | 显示全部楼层
多谢分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 6881个

财富等级: 富甲天下

发表于 2022-12-28 12:24:43 | 显示全部楼层
谢谢版主的分享
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-2-28 10:26 , Processed in 0.433384 second(s), 59 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表